VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MSE"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Function Calculate(ByRef gxptTarget As Variant, _
                          ByRef gxptOutput As Variant, _
                          ByRef gxptParams As Variant, _
                          ByRef gxptModelInfo As Variant) As Variant


    'This method must be called always. Internally it uses caching to minimize
    'any performance penalty. Replace the file path below with the path of the run you are using.
    DataHelper.Initialise "c:\Acot.gep", gxptTarget, gxptOutput, gxptParams, gxptModelInfo

    'These are examples of the interface available to you
    
    'This is how you access the values in the current set
    Debug.Print DataHelper.GetDoubleValue(0, 0, dsTrainingSet)
    
    'This property returns the set that is now being passed to this
    'fitness function. It relies on both sets having a different number of
    'samples so it does not work when both the Training and Testing set
    'have the same number of samples.
    Debug.Print DataHelper.CurrentSet
    
    'Returns the number of variables plus the dependent variable
    Debug.Print DataHelper.Columns
    
    'Returns the number of samples in use in the Training set
    Debug.Print DataHelper.TrainingSamples
    
    'Returns the number of samples in use in the Testing set
    Debug.Print DataHelper.TestingSamples
    
    'Returns the last error after a DataHelper call. You should
    'check if DataHelper.ErrorNumber is not zero to ensure that
    'the previous call did not fail.
    If DataHelper.ErrorNumber > 0 Then
        Debug.Print DataHelper.ErrorDescription
    End If

    '-------------------------------------------------------------------
    'Implementation of the MSE fitness function
    Dim nSamples As Long: nSamples = gxptParams(0)
    Dim modelMinusTargetSquared As Double
    Dim MSE As Double
    Dim temp1 As Double
    Dim i As Long
        
    For i = 0 To nSamples - 1
    
        temp1 = 0
        temp1 = gxptOutput(i) - gxptTarget(i)
        temp1 = temp1 * temp1
        modelMinusTargetSquared = modelMinusTargetSquared + temp1
    Next

    MSE = modelMinusTargetSquared / nSamples

    If MSE <= 0.000000001 Then
        MSE = 0#
    End If

    Calculate = (1 / (1 + MSE)) * 1000
    
End Function

Private Sub Class_Initialize()
    
    If DataHelper Is Nothing Then
        Set DataHelper = New GXPT4CFHelper.DataSet
    End If
End Sub

